#include "font.ch"
#include "xbp.ch"
#include "gra.ch"
#include "appevent.ch"

#define MYSQL_FS_TYPEXBASE       2     /*Type of field Xbase */

STATIC lUseDBF := .T.

PROCEDURE appsys()
return

PROCEDURE MAIN()
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oT2
LOCAL oDlg
LOCAL oPS
LOCAL lExit := .f.
LOCAL oCon     := NIL
LOCAL cTable   := "bmpdb"

#IFDEF MYSQL
LOCAL cHost    := "myhost"
LOCAL cUser    := "tessti"
LOCAL cPwd     := "geheim"
LOCAL nPort    := 3306
LOCAL cDb      :=  "mdidemo"
LOCAL bSaveError, oError
#ENDIF

   IF PCOUNT() > 0
      lUseDBF := .F.
   ENDIF

   IF lUseDBF = .T.
      DbeLoad("FOXDBE",.F.)
      DbeSetDefault("FOXDBE")
      SET DEFAULT TO "C:\ALASKA\XPPW32\Source\samples\DATA"

   ELSE
      #IFDEF MYSQL
      bSaveError := ERRORBLOCK()
      ERRORBLOCK( { | e | BREAK( e ) } )

      BEGIN SEQUENCE

      oCon := MySql() :New()
      IF oCon:RealConnect( cHost, cUser, cPwd, "", nPort )
         //
         IF !oCon:ExisteDb( LOWER( cDb ) )
            Msgbox( "Error Catalog " + cDb + " does not exist" )
            BREAK
         ENDIF
         oCon:SelectDb( cDb )

         IF !( oCon:ExistTables( LOWER(cTable) ) )
            Msgbox( 'Table ' + cTable + ' does not exist on Catalog '+cDb )
            BREAK
         ENDIF
      ENDIF

      RECOVER
      ERRORBLOCK( bSaveError )
      QUIT

      END SEQUENCE
      ERRORBLOCK( bSaveError )                                 // Alten Fehler-Codeblock
      #ENDIF
   ENDIF

   oDlg := XBPDIALOG() :new( APPDESKTOP(),,,,,.F. )
   oDlg:close := { | mp1, mp2, obj | lExit := .T. }
   oDlg:create()
   //
   // warum MUSS hier ein CenterControl() stehen ?
   //
   CenterControl(oDlg)
   //
   //
   //
   oDlg:show()

   oPS := XBPPRESSPACE() :new() :create( oDlg:drawingArea:winDevice() )
   SetAppFocus(oDlg)

   oT2 := Thread():New()
   oT2:start("drawBitmapFromDB","BMPDB.DBF",oCon,cTable,oDlg,oPS)

   nEvent := xbeP_None
   DO WHILE !lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp,1 )
      DO CASE
         CASE nEvent == xbe_None                            // nTimeout eingetreten

         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            EXIT
      OTHERWISE
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oT2:synchronize(0)

RETURN

FUNCTION drawBitmapFromDB(cFile,oCon,cTable,oDlg,oPS)
LOCAL oBMP, nEvent
LOCAL oTbl,nPos
LOCAL aAS    := Array( GRA_AS_COUNT )
LOCAL nStart := SECONDS()
LOCAL mp1
LOCAL aRes
LOCAL cFeld
LOCAL aSize  := {0,0}

   IF lUseDBF = .T.
      USE (cFile) EXCLUSIVE
   ELSE
      #IFDEF MYSQL
      oTbl := MyResult() :New( oCon,,cTable )
      oTbl:OpenRecord()
      nPos := ASCAN( oTbl:aStructSql, { | x | UPPER( x[ MYSQL_FS_TYPEXBASE ] ) = "V" } )
      #ENDIF
   ENDIF

   aAS[GRA_AS_COLOR]     := GRA_CLR_YELLOW
   aAS[GRA_AS_BACKCOLOR] := GRA_CLR_BLUE
   GraSetAttrString(oPS , aAS )

   oBMP:= XbpBitmap():new():create( oPS )

   IF lUseDBF = .T.
      oBMP:setBuffer(FIELD->BITMAP,XBPBMP_FORMAT_WIN3X)
   ELSE
      #IFDEF MYSQL
      aRes  := oTbl:RecordGet()
      cFeld := aRes[nPos]
      oBMP:setBuffer( cFeld )
      #ENDIF
   ENDIF

   aSize[1] := oBMP:xSize
   aSize[2] := oBMP:ySize

   IF aSize[1] = 0 .AND. aSize[2] = 0
      Msgbox("Image Size = 0 ???")
      IF lUseDBF = .T.
         USE
      ELSE
         #IFDEF MYSQL
         oTbl:Close()
         #ENDIF
      ENDIF
      oPS:destroy()
      oDlg:destroy()
      RETURN .F.
   ENDIF

   aSize[2] += 10
   oDlg:clientSize := aSize

   CenterControl(oDlg)
   oDlg:show()
   setAppWindow(oDlg)
   setAppFocus(oDlg)

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close .AND. !(nEvent = xbeP_Keyboard .AND. mp1 == xbeK_ESC)
      nEvent := LastAppEvent(@mp1,,,1)

      IF lUseDBF = .T.
         oBMP:setBuffer(FIELD->BITMAP,XBPBMP_FORMAT_WIN3X)
         oBMP:draw(oPS,{0,10})
      ELSE
         #IFDEF MYSQL
         oBMP:setBuffer(oTbl:RecordGet()[nPos])
         oBMP:draw(oPS,{0,10})
         #ENDIF
      ENDIF

      IF lUseDBF = .T.
         IF(EOF())
            GraBox(oPS , {0,0} , {aSize[1],10} ,GRA_FILL )
            GraStringAt(oPS,{(aSize[1]/2)-50,0},STR(SECONDS()-nStart)+" Sec.")
            DbGoTop()
            nStart := SECONDS()
         ELSE
            DbSkip(1)
         ENDIF
      ELSE
         #IFDEF MYSQL
         IF oTbl:Eof()
            GraBox(oPS , {0,0} , {aSize[1],10} ,GRA_FILL )
            GraStringAt(oPS,{(aSize[1]/2)-50,0},STR(SECONDS()-nStart)+" Sec.")
            oTbl:GoTop()
            nStart := SECONDS()
         ELSE
            oTbl:Skip( 1 )
         ENDIF
         #ENDIF
      ENDIF
   ENDDO

   IF lUseDBF = .T.
      USE
   ELSE
      #IFDEF MYSQL
      oTbl:Close()
      #ENDIF
   ENDIF


RETURN NIL

*
*
*
